/*
 * This is "Table II, Truth Table" for the MM5740/AAC or MM5740/AAD,
 * AN-139, page 10-39 (page 18 of MM5740andAppNote.pdf).
 * Each entry is augmented with a string indicating the H19 key for each row/column
 * in the scan matrix.
 *
 * "u_" is for unmodified (neither SHIFT nor CTRL),
 * "s_" is for SHIFT
 * "c_" is for CTRL
 * "sc_" is for SHIFT+CTRL
 *
 * Note, like in the app note, these values are inverted. "1" actually means a logic "0".
 *
 * Also note, the truth table, both here and in the app note, is presented in
 * numerical order (B6 is LSB, B1 is MSB, then B7,B8 add SHIFT/CTRL modification). This
 * table was generated as a simple ordinal sequence of binary values - it was
 * not generated from an OCR of the app note.
 */
struct mm5740_s {
	char *key;
	int b1, b2, b3, b4, b9;
	int u_b5, u_b6, u_b7, u_b8;
	int s_b5, s_b6, s_b7, s_b8;
	int c_b5, c_b6, c_b7, c_b8;
	int sc_b5, sc_b6, sc_b7, sc_b8;
} h19_mm5740[10][11] = {
[1][1] = {"slash", 1, 1, 1, 1, 1,  1, 1, 1, 1,  1, 1, 1, 0,  1, 1, 0, 1,  1, 1, 0, 0 },
[1][2] = {NULL, 1, 1, 1, 1, 1,  1, 0, 1, 1,  1, 0, 1, 0,  1, 0, 0, 1,  1, 0, 0, 0 },
[1][3] = {NULL, 1, 1, 1, 1, 1,  0, 1, 1, 1,  0, 1, 1, 0,  0, 1, 0, 1,  0, 1, 0, 0 },
[1][4] = {NULL, 1, 1, 1, 1, 1,  0, 0, 1, 1,  0, 0, 1, 0,  0, 0, 0, 1,  0, 0, 0, 0 },
[1][5] = {"X2", 1, 1, 1, 1, 0,  1, 1, 1, 1,  1, 1, 1, 0,  1, 1, 0, 1,  1, 1, 0, 0 },
[1][6] = {NULL, 1, 1, 1, 1, 0,  1, 0, 1, 1,  1, 0, 1, 0,  1, 0, 0, 1,  1, 0, 0, 0 },
[1][7] = {"KP_0", 1, 1, 1, 1, 0,  0, 1, 1, 1,  0, 1, 1, 0,  0, 1, 0, 1,  0, 1, 0, 0 },
[1][8] = {"KP_DP", 1, 1, 1, 1, 0,  0, 0, 1, 1,  0, 0, 1, 0,  0, 0, 0, 1,  0, 0, 0, 0 },
[1][9] = {"KP_ENTER", 1, 1, 1, 0, 1,  1, 1, 1, 1,  1, 1, 1, 0,  1, 1, 0, 1,  1, 1, 0, 0 },
[1][10] = {NULL, 1, 1, 1, 0, 1,  1, 0, 1, 1,  1, 0, 1, 0,  1, 0, 0, 1,  1, 0, 0, 0 },
[2][1] = {"colon", 1, 1, 1, 0, 1,  0, 1, 1, 1,  0, 1, 1, 0,  0, 1, 0, 1,  0, 1, 0, 0 },
[2][2] = {"apos", 1, 1, 1, 0, 1,  0, 0, 1, 1,  0, 0, 1, 0,  0, 0, 0, 1,  0, 0, 0, 0 },
[2][3] = {"brace", 1, 1, 1, 0, 0,  1, 1, 1, 1,  1, 1, 1, 0,  1, 1, 0, 1,  1, 1, 0, 0 },
[2][4] = {"RETURN", 1, 1, 1, 0, 0,  1, 0, 1, 1,  1, 0, 1, 0,  1, 0, 0, 1,  1, 0, 0, 0 },
[2][5] = {NULL, 1, 1, 1, 0, 0,  0, 1, 1, 1,  0, 1, 1, 0,  0, 1, 0, 1,  0, 1, 0, 0 },
[2][6] = {NULL, 1, 1, 1, 0, 0,  0, 0, 1, 1,  0, 0, 1, 0,  0, 0, 0, 1,  0, 0, 0, 0 },
[2][7] = {"KP_1", 1, 1, 0, 1, 1,  1, 1, 1, 1,  1, 1, 1, 0,  1, 1, 0, 1,  1, 1, 0, 0 },
[2][8] = {"KP_2", 1, 1, 0, 1, 1,  1, 0, 1, 1,  1, 0, 1, 0,  1, 0, 0, 1,  1, 0, 0, 0 },
[2][9] = {"KP_3", 1, 1, 0, 1, 1,  0, 1, 1, 1,  0, 1, 1, 0,  0, 1, 0, 1,  0, 1, 0, 0 },
[2][10] = {NULL, 1, 1, 0, 1, 1,  0, 0, 1, 1,  0, 0, 1, 0,  0, 0, 0, 1,  0, 0, 0, 0 },
[3][1] = {"P", 1, 1, 0, 1, 0,  1, 1, 1, 1,  1, 1, 1, 0,  1, 1, 0, 1,  1, 1, 0, 0 },
[3][2] = {"bracket", 1, 1, 0, 1, 0,  1, 0, 1, 1,  1, 0, 1, 0,  1, 0, 0, 1,  1, 0, 0, 0 },
[3][3] = {"backslash", 1, 1, 0, 1, 0,  0, 1, 1, 1,  0, 1, 1, 0,  0, 1, 0, 1,  0, 1, 0, 0 },
[3][4] = {"LF", 1, 1, 0, 1, 0,  0, 0, 1, 1,  0, 0, 1, 0,  0, 0, 0, 1,  0, 0, 0, 0 },
[3][5] = {"DEL", 1, 1, 0, 0, 1,  1, 1, 1, 1,  1, 1, 1, 0,  1, 1, 0, 1,  1, 1, 0, 0 },
[3][6] = {NULL, 1, 1, 0, 0, 1,  1, 0, 1, 1,  1, 0, 1, 0,  1, 0, 0, 1,  1, 0, 0, 0 },
[3][7] = {"KP_4", 1, 1, 0, 0, 1,  0, 1, 1, 1,  0, 1, 1, 0,  0, 1, 0, 1,  0, 1, 0, 0 },
[3][8] = {"KP_5", 1, 1, 0, 0, 1,  0, 0, 1, 1,  0, 0, 1, 0,  0, 0, 0, 1,  0, 0, 0, 0 },
[3][9] = {"KP_6", 1, 1, 0, 0, 0,  1, 1, 1, 1,  1, 1, 1, 0,  1, 1, 0, 1,  1, 1, 0, 0 },
[3][10] = {NULL, 1, 1, 0, 0, 0,  1, 0, 1, 1,  1, 0, 1, 0,  1, 0, 0, 1,  1, 0, 0, 0 },
[4][1] = {"0", 1, 1, 0, 0, 0,  0, 1, 1, 1,  0, 1, 1, 0,  0, 1, 0, 1,  0, 1, 0, 0 },
[4][2] = {"dash", 1, 1, 0, 0, 0,  0, 0, 1, 1,  0, 0, 1, 0,  0, 0, 0, 1,  0, 0, 0, 0 },
[4][3] = {"equal", 1, 0, 1, 1, 1,  1, 1, 1, 1,  1, 1, 1, 0,  1, 1, 0, 1,  1, 1, 0, 0 },
[4][4] = {"acute", 1, 0, 1, 1, 1,  1, 0, 1, 1,  1, 0, 1, 0,  1, 0, 0, 1,  1, 0, 0, 0 },
[4][5] = {"BS", 1, 0, 1, 1, 1,  0, 1, 1, 1,  0, 1, 1, 0,  0, 1, 0, 1,  0, 1, 0, 0 },
[4][6] = {"X1", 1, 0, 1, 1, 1,  0, 0, 1, 1,  0, 0, 1, 0,  0, 0, 0, 1,  0, 0, 0, 0 },
[4][7] = {"KP_7", 1, 0, 1, 1, 0,  1, 1, 1, 1,  1, 1, 1, 0,  1, 1, 0, 1,  1, 1, 0, 0 },
[4][8] = {"KP_8", 1, 0, 1, 1, 0,  1, 0, 1, 1,  1, 0, 1, 0,  1, 0, 0, 1,  1, 0, 0, 0 },
[4][9] = {"KP_9", 1, 0, 1, 1, 0,  0, 1, 1, 1,  0, 1, 1, 0,  0, 1, 0, 1,  0, 1, 0, 0 },
[4][10] = {NULL, 1, 0, 1, 1, 0,  0, 0, 1, 1,  0, 0, 1, 0,  0, 0, 0, 1,  0, 0, 0, 0 },
[5][1] = {"f1", 1, 0, 1, 0, 1,  1, 1, 1, 1,  1, 1, 1, 0,  1, 1, 0, 1,  1, 1, 0, 0 },
[5][2] = {"f2", 1, 0, 1, 0, 1,  1, 0, 1, 1,  1, 0, 1, 0,  1, 0, 0, 1,  1, 0, 0, 0 },
[5][3] = {"f3", 1, 0, 1, 0, 1,  0, 1, 1, 1,  0, 1, 1, 0,  0, 1, 0, 1,  0, 1, 0, 0 },
[5][4] = {"f4", 1, 0, 1, 0, 1,  0, 0, 1, 1,  0, 0, 1, 0,  0, 0, 0, 1,  0, 0, 0, 0 },
[5][5] = {"f5", 1, 0, 1, 0, 0,  1, 1, 1, 1,  1, 1, 1, 0,  1, 1, 0, 1,  1, 1, 0, 0 },
[5][6] = {"ERASE", 1, 0, 1, 0, 0,  1, 0, 1, 1,  1, 0, 1, 0,  1, 0, 0, 1,  1, 0, 0, 0 },
[5][7] = {"BLUE", 1, 0, 1, 0, 0,  0, 1, 1, 1,  0, 1, 1, 0,  0, 1, 0, 1,  0, 1, 0, 0 },
[5][8] = {"RED", 1, 0, 1, 0, 0,  0, 0, 1, 1,  0, 0, 1, 0,  0, 0, 0, 1,  0, 0, 0, 0 },
[5][9] = {"GRAY", 1, 0, 0, 1, 1,  1, 1, 1, 1,  1, 1, 1, 0,  1, 1, 0, 1,  1, 1, 0, 0 },
[5][10] = {NULL, 1, 0, 0, 1, 1,  1, 0, 1, 1,  1, 0, 1, 0,  1, 0, 0, 1,  1, 0, 0, 0 },
[6][1] = {"Z", 1, 0, 0, 1, 1,  0, 1, 1, 1,  0, 1, 1, 0,  0, 1, 0, 1,  0, 1, 0, 0 },
[6][2] = {"X", 1, 0, 0, 1, 1,  0, 0, 1, 1,  0, 0, 1, 0,  0, 0, 0, 1,  0, 0, 0, 0 },
[6][3] = {"C", 1, 0, 0, 1, 0,  1, 1, 1, 1,  1, 1, 1, 0,  1, 1, 0, 1,  1, 1, 0, 0 },
[6][4] = {"V", 1, 0, 0, 1, 0,  1, 0, 1, 1,  1, 0, 1, 0,  1, 0, 0, 1,  1, 0, 0, 0 },
[6][5] = {"B", 1, 0, 0, 1, 0,  0, 1, 1, 1,  0, 1, 1, 0,  0, 1, 0, 1,  0, 1, 0, 0 },
[6][6] = {"N", 1, 0, 0, 1, 0,  0, 0, 1, 1,  0, 0, 1, 0,  0, 0, 0, 1,  0, 0, 0, 0 },
[6][7] = {"M", 1, 0, 0, 0, 1,  1, 1, 1, 1,  1, 1, 1, 0,  1, 1, 0, 1,  1, 1, 0, 0 },
[6][8] = {"comma", 1, 0, 0, 0, 1,  1, 0, 1, 1,  1, 0, 1, 0,  1, 0, 0, 1,  1, 0, 0, 0 },
[6][9] = {"period", 1, 0, 0, 0, 1,  0, 1, 1, 1,  0, 1, 1, 0,  0, 1, 0, 1,  0, 1, 0, 0 },
[6][10] = {"space", 1, 0, 0, 0, 1,  0, 0, 1, 1,  0, 0, 1, 0,  0, 0, 0, 1,  0, 0, 0, 0 },
[7][1] = {"A", 1, 0, 0, 0, 0,  1, 1, 1, 1,  1, 1, 1, 0,  1, 1, 0, 1,  1, 1, 0, 0 },
[7][2] = {"S", 1, 0, 0, 0, 0,  1, 0, 1, 1,  1, 0, 1, 0,  1, 0, 0, 1,  1, 0, 0, 0 },
[7][3] = {"D", 1, 0, 0, 0, 0,  0, 1, 1, 1,  0, 1, 1, 0,  0, 1, 0, 1,  0, 1, 0, 0 },
[7][4] = {"F", 1, 0, 0, 0, 0,  0, 0, 1, 1,  0, 0, 1, 0,  0, 0, 0, 1,  0, 0, 0, 0 },
[7][5] = {"G", 0, 1, 1, 1, 1,  1, 1, 1, 1,  1, 1, 1, 0,  1, 1, 0, 1,  1, 1, 0, 0 },
[7][6] = {"H", 0, 1, 1, 1, 1,  1, 0, 1, 1,  1, 0, 1, 0,  1, 0, 0, 1,  1, 0, 0, 0 },
[7][7] = {"J", 0, 1, 1, 1, 1,  0, 1, 1, 1,  0, 1, 1, 0,  0, 1, 0, 1,  0, 1, 0, 0 },
[7][8] = {"K", 0, 1, 1, 1, 1,  0, 0, 1, 1,  0, 0, 1, 0,  0, 0, 0, 1,  0, 0, 0, 0 },
[7][9] = {"L", 0, 1, 1, 1, 0,  1, 1, 1, 1,  1, 1, 1, 0,  1, 1, 0, 1,  1, 1, 0, 0 },
[7][10] = {"SCROLL", 0, 1, 1, 1, 0,  1, 0, 1, 1,  1, 0, 1, 0,  1, 0, 0, 1,  1, 0, 0, 0 },
[8][1] = {"Q", 0, 1, 1, 1, 0,  0, 1, 1, 1,  0, 1, 1, 0,  0, 1, 0, 1,  0, 1, 0, 0 },
[8][2] = {"W", 0, 1, 1, 1, 0,  0, 0, 1, 1,  0, 0, 1, 0,  0, 0, 0, 1,  0, 0, 0, 0 },
[8][3] = {"E", 0, 1, 1, 0, 1,  1, 1, 1, 1,  1, 1, 1, 0,  1, 1, 0, 1,  1, 1, 0, 0 },
[8][4] = {"R", 0, 1, 1, 0, 1,  1, 0, 1, 1,  1, 0, 1, 0,  1, 0, 0, 1,  1, 0, 0, 0 },
[8][5] = {"T", 0, 1, 1, 0, 1,  0, 1, 1, 1,  0, 1, 1, 0,  0, 1, 0, 1,  0, 1, 0, 0 },
[8][6] = {"Y", 0, 1, 1, 0, 1,  0, 0, 1, 1,  0, 0, 1, 0,  0, 0, 0, 1,  0, 0, 0, 0 },
[8][7] = {"U", 0, 1, 1, 0, 0,  1, 1, 1, 1,  1, 1, 1, 0,  1, 1, 0, 1,  1, 1, 0, 0 },
[8][8] = {"I", 0, 1, 1, 0, 0,  1, 0, 1, 1,  1, 0, 1, 0,  1, 0, 0, 1,  1, 0, 0, 0 },
[8][9] = {"O", 0, 1, 1, 0, 0,  0, 1, 1, 1,  0, 1, 1, 0,  0, 1, 0, 1,  0, 1, 0, 0 },
[8][10] = {"TAB", 0, 1, 1, 0, 0,  0, 0, 1, 1,  0, 0, 1, 0,  0, 0, 0, 1,  0, 0, 0, 0 },
[9][1] = {"1", 0, 1, 0, 1, 1,  1, 1, 1, 1,  1, 1, 1, 0,  1, 1, 0, 1,  1, 1, 0, 0 },
[9][2] = {"2", 0, 1, 0, 1, 1,  1, 0, 1, 1,  1, 0, 1, 0,  1, 0, 0, 1,  1, 0, 0, 0 },
[9][3] = {"3", 0, 1, 0, 1, 1,  0, 1, 1, 1,  0, 1, 1, 0,  0, 1, 0, 1,  0, 1, 0, 0 },
[9][4] = {"4", 0, 1, 0, 1, 1,  0, 0, 1, 1,  0, 0, 1, 0,  0, 0, 0, 1,  0, 0, 0, 0 },
[9][5] = {"5", 0, 1, 0, 1, 0,  1, 1, 1, 1,  1, 1, 1, 0,  1, 1, 0, 1,  1, 1, 0, 0 },
[9][6] = {"6", 0, 1, 0, 1, 0,  1, 0, 1, 1,  1, 0, 1, 0,  1, 0, 0, 1,  1, 0, 0, 0 },
[9][7] = {"7", 0, 1, 0, 1, 0,  0, 1, 1, 1,  0, 1, 1, 0,  0, 1, 0, 1,  0, 1, 0, 0 },
[9][8] = {"8", 0, 1, 0, 1, 0,  0, 0, 1, 1,  0, 0, 1, 0,  0, 0, 0, 1,  0, 0, 0, 0 },
[9][9] = {"9", 0, 1, 0, 0, 1,  1, 1, 1, 1,  1, 1, 1, 0,  1, 1, 0, 1,  1, 1, 0, 0 },
[9][10] = {"ESC", 0, 1, 0, 0, 1,  1, 0, 1, 1,  1, 0, 1, 0,  1, 0, 0, 1,  1, 0, 0, 0 },
};
